Skip to content
New issue

Exposure of HashMap iteration order allows for O(n²) blowup. #36481

Open
Veedrac opened this issue on Sep 14, 2016 · 97 comments

Comments

@Veedrac
Contributor

Veedrac commented on Sep 14, 2016

Exposing HashMap's iteration order can cause O(n²) blowup even in innocent-looking code without the presence of an attacker. In the presence of an attacker, access to the order of a dictionary allows HashDoS-like attacks with only two requests in common scenarios.

Without an attacker

Consider a user with two possibly-disjoint hash maps

let first_map: HashMap<u64, _> = (0..900000).map(|i| (i, ())).collect();
let second_map: HashMap<u64, _> = (900000..1800000).map(|i| (i, ())).collect();

The user wants to merge the hash maps, and does so naïvely,

let mut merged = first_map;
merged.extend(second_map);

Time for merge when second_map is shuffled: 0.4s

Time for merge when second_map is not shuffled: 40.s (x100 amplification)

This effect is noticeably more pronounced when merging with a round robin strategy.

With an attacker

The threat model here is simple. The attacker is able to send JSON to the server. The server parses the JSON into a HashMap and through whatever means - an error message including the formatted map or explicit listing of the contents of the map - may reveal the order of the map.

The attack on this model requires two requests. The first sends some large JSON to the server

let first_request: HashMap<u64, _> = (0..900000).map(|i| (i, ())).collect();

and recieves an ordering

let returned_data: Vec<_> = first_request.into_iter().collect();

The attacker then sends the first and third quarter of this list in a new JSON object.

let second_request: HashMap<u64, _> =
 returned_data[..225000].iter()
     .chain(&returned_data[450000..675000])
     .cloned().collect();

Total time without second request: 0.1s

Total time with second request: 200s (x2000 amplification)


Solutions, near-solutions and non-solutions

These solutions should not be considered to be ordered, necessarily disjoint, nor an exhaustive list of options.

Fall back to BTreeMap

It should be clear that we cannot treat hash maps as a solved problem just because we use SipHash. In fact, SipHash is entirely insufficient to solve the problem. My first suggestion is thus to stop trying to make the hasher secure, and instead fall back to BTreeMap when nonlinear behaviour is detected.

This guarantees a minimum level of performance regardless of the capabilities of the attacker, and allows usage of a faster hashing algorithm by default. Hash maps should get faster by default as a result. This does not prevent having to consider the issue, since the fallback is costly and must be rare, but this is an easier problem than entirely securing the hash map.

Use a hash map without problematic blowup, or less affected by it

Java solves this problem by using a hash map with chaining and converting large buckets to tree maps. This mitigates the impact of degradation, but does not seem to allow using contiguous hash maps by default.

As far as I am aware, the blowup cannot be resolved by moving to another common form of open addressing, although quadratic probing would be significantly less affected by some of these attacks. Chaining alone also defeats the attacks given here, but still requires a secure hash and fails with attackers with more capabilities.

Use different seeds for each hash map

Pull requests #31356 (closed) and #33318 (merged) first proposed incrementing the thread local seed for each hash map. This was later removed when no threat model was seen, but would prevent both attacks listed here.

This still allows attacks when hash maps are reused.

Randomize iteration order

I am not sure how one would randomize iteration order efficiently. However, it should solve the problem unless hashes are exposed through other means.

Ignore the problem

Given that Rust went so far as to use SipHash, quadratic blowup on code as simple as fst.extend(snd) seems too extreme to ignore.

@sfackler
Member

sfackler commented on Sep 14, 2016

It seems to me like we should basically just revert #33318 for now and use different seeds per map. Ideally we could find a strategy that avoids key reuse but also doesn't regress hashmap creation performance too much, but as @briansmith noted in #33318 there are risks to using multiple correlated keys as well.

@briansmith

The threat model here is simple. The attacker is able to send JSON to the server. The server parses the JSON into a HashMap and through whatever means - an error message including the formatted map or explicit listing of the contents of the map - may reveal the order of the map.

Perhpas we can resolve this by just saying this is outside the threat model. And/or, the Debug implementation for a HashMap isn't performance-sensitive in most applications, and so it could be redone to always output the values in sorted order by key--i.e. it could make a copy of itself into a BTreeMap and then Debug::fmt the BTreeMap. This seems reasonable since either the HashMap is small or it is probably too gigantic to reasonably expect to format in the first place. (Note that HashMap doesn't implement Display, not should it.)

@sfackler
Member

sfackler commented on Sep 14, 2016

We'd also have to mandate a sort in JSON serialization, which seems somewhat unreasonable.

The fact that simply merging two maps can run into sadness makes it seem to me like we have to do something about this.

@Veedrac
Contributor Author

Veedrac commented on Sep 14, 2016

You can't always sort a hashmap because the keys aren't required to be Ord. This doesn't matter for the BTreeMap fallback because you can sort by hash code (note: this means it's required to use a cryptographic hash), but sorting by hash is exactly the opposite of what you want to do when you don't have that fallback.

@sfackler
Member

sfackler commented on Sep 14, 2016

A shuffle would do fine though I think.

@eternaleye
Contributor

eternaleye commented on Sep 15, 2016

@briansmith: Debug is just a trivial example of how the information might leak, though, not the actual issue.

Another example would be if a web service validates the JSON it's given key-by-key, by iterating over (key, value) pairs and delegating to a validation function.

  • If it returns the first error it encounters, the attacker can learn the order.
  • If it errors early, even without a descriptive message, the attacker can learn the order.
  • If it collects the errors and returns them without shuffling (or sorting), the attacker can learn the order.

It's a footgun.

@Veedrac
Contributor Author

Veedrac commented on Sep 15, 2016

We could also use Python's technique to preserve insertion order. It introduces a little more indirection, but the cost doesn't seem to be excessive.

This also makes hash map order deterministic, which is a nice usability bonus. Note that tombstones aren't required for determinism, but are required to preserve insertion order through deletions. Either way prevents the attacks given.

@arthurprs
Contributor

arthurprs commented on Sep 15, 2016

Revisiting #33318 sounds like the reasonable way out.

@arielb1
Contributor

arielb1 commented on Sep 15, 2016

HashMap creation needs to be fast in the common case. I think we need a HashMap that defaults to FNV but rehashes with a random SIP key when it gets too much collisions.

@eternaleye
Contributor

eternaleye commented on Sep 15, 2016

TBH, I'm also curious how alternate approaches (a BTreeMap whose nodes are stored in an overallocated Vec, for similar allocation amortization as HashMap; a trie or crit-bit tree keyed on hashes with the same allocation style, etc) would perform.

Both would likely avoid the pathological merging behavior, and the amortized allocations may bring them closer to HashMap.

@arielb1
Contributor

arielb1 commented on Sep 15, 2016

So the problem here is not hard collisions, but rather soft collisions?

@bluss
Member

bluss commented on Sep 15, 2016

@Veedrac It has some wins too, since the data that needs to be swapped by bucket stealing while inserting is smaller, and iteration is much faster since it's on a mostly compact space. But the indirection costs in lookup may not be acceptable at all. (I made a prototype that demonstrates exactly these differences with a +6% hit to lookup.)

Maybe if one moves the hash field to be next to the index, or even special case smaller than 2**32 maps so that they keep 32-bit hashes and 32-bit indices next to each other?

@Veedrac
Contributor Author

Veedrac commented on Sep 15, 2016

@bluss The new layout should allow you to lower the occupancy (perhaps cap it at 80%?) without paying much of a hit, since the key/value arrays can safely cap out at 100% - only the index array needs to grow. This should get you some speed back, as well as make pathological insertions a lot rarer.

@Veedrac
Contributor Author

Veedrac commented on Sep 15, 2016

@arielb1 Exactly; the first half of the table is ending up with significantly over 100% occupancy.

@Veedrac
Contributor Author

Veedrac commented on Sep 16, 2016

Some extra discussion is available in this Reddit thread, including back of the envelope analysis of the asymptotics and commentary on a similar attack mentioned in the SipHash paper.

@bluss
Member

bluss commented on Sep 16, 2016

the consistent order map prototype is here https://github.com/bluss/ordermap I actually began that not because of this thread but due to curiosity about the new dict representation in Python 3.6.

Removal breaks the insert order property. Otherwise you need tombstones (ideas/forks for efficient way of doing that are welcome).

Conclusions: iteration can be so much faster than libstd HashMap. Growth too. Lookup is slightly slower (more than the 6% I said above if the map is large and out of cache). It solves the merge pathology.

@sfackler
Member

sfackler commented on Sep 16, 2016

That looks pretty awesome at first glance.

I don't think like we need to guarantee insertion order iteration, but it would be nice to make it iterate more obviously in not-insertion order - maybe alternate adding to the front and back of the iteration list or something like that? Probably not worth doing if it'd get complex.

@bluss
Member

bluss commented on Sep 16, 2016

However it looks in this issue, the current HashMap impl has lots of aspects in which its performance is great already. Don't think it's that easy to replace it.

@sfackler
Member

sfackler commented on Sep 16, 2016

Oh yeah, absolutely. It's just good to see that there are reasonable routes forward.

@Veedrac
Contributor Author

Veedrac commented on Sep 16, 2016

@bluss Safe, stable Rust and only 6% slower insertion normally? Amazing work.

@bluss
Member

bluss commented on Sep 19, 2016

The particular representation in ordermap maps well to safe rust (using vectors without holes). Making accurate benchmarks is tricky (there are so many different scenarios), I can only ask for help there, and my general summary is in the readme.

@alexcrichton
Member

alexcrichton commented on Sep 29, 2016

The libs team discussed this during triage yesterday and the conclusion was that while we'd definitely like to fix this it's not absolutely critical we do so immediately. We don't mind taking a bit of time to explore our options like @bluss's crate.

@alexcrichton alexcrichton added P-high and removed I-nominated labels on Sep 29, 2016
@bluss
Member

bluss commented on May 1, 2017

Thanks

@stjepang
Contributor

stjepang commented on Oct 14, 2017

Any progress on this? Do we have a plan for fixing the DoS unsafety?

@arthurprs
Contributor

arthurprs commented on Oct 14, 2017

There's a bit of history in this thread, so I'll try to summarize the current state bellow.

#38368 improved things immensely by detecting degenerate probe lengths and/or forward shifting on insert. There's also a check for minimum occupancy in order to trigger the early resize (so a runtime attack don't become a memory attack). This is somewhat similar to Java's solution. They convert the linked-list collision chain into a balanced-tree when the length crosses a threshold.

So there's still a small area that an attacker can exploit, by crafting inputs that cause extra work below those limits. That's really small though and I didn't test if one can actually exploit it.

Edit: Also, default hasher gives each hashmap a different seed (clone() retains the seed though), but that's orthogonal to the above.

@alkis
Contributor

alkis commented on Oct 23, 2017

Here's a general solution to the problem. after every rehash or clone, reseed the hasher. It will regress the performance of rehash but it will solve the O(n²) problem. Luckily in production code (as a whole) lookups dominate insertions by a large margin so the tradeoff is actually sound.

Note: if you end up going this route it might no longer make sense to store the full hashes in the hashtable as they are not going to help when rehashing (they are still going to save comparisons but it is likely that the costs outweigh the benefits). You can instead store the distance from the ideal position in a u8. This will reduce the amount of memory touched until finding the element or terminating the search.

@funny-falcon

@alkis

it might no longer make sense to store the full hashes ...
they are still going to save comparisons

Storing of 8bits of hash is enough to save comparisons. Actually, I even stored 7bits with great result (using 8bit for other purpose).
If this "hashik" is always non-zero (ie calculated as hshik = hash % 251 + 1), then it could role of "presence" flag.
(Module by a constant is optimized by compiler into two multiplications).

@arthurprs
Contributor

arthurprs commented on Oct 24, 2017

That's not general as it requires support from the hasher, most just initialize to the same seed. Edit: can be made general by hashing the table address as well #36481 (comment)

I don't think that's a reasonable tradeoff for a stdlib hasher, growing and cloning the hashmap becomes much much slower. As the slot moving is essentially randomized it'll require a lot of random access and Robin hood adjustments as things go into the new table. The fact that sip isn't the fastest hasher around just makes it even worse.

@alkis
Contributor

alkis commented on Oct 24, 2017

@funny-falcon if we store 8-bits of hash for comparisons then we can't bail out early from probe chains based on distance from ideal position. It basically voids the Robin Hood. Or perhaps I misunderstood your suggestion.

@arthurprs yes either BuildHasher or Hasher traits need an additional requirement. BuildHasher can support it by requiring Default and Hasher by allowing setting the seed. You are right there is going to be a performance hit - I already mentioned it "it regresses the performance of rehash". I posit there is no win-win solution here. You either take performance hit by shuffling the order on rehash or you have O(n²) on insertion. As already mentioned, in the global scheme of things this does not matter: insertions happen orders of magnitude less often than lookups. Also a lot of the regression can be mitigated by using reserve().

@funny-falcon

@alkis , I mean, store both 8bits of hash + 8bits distance. So, 16 bits in total.
Storing just 16bits of hash is less meaningful, cause in big table they all will be equal for same position.
(that is another reason why "hashik" is modulo prime: for same table position there will be 251 different "hashik").

@alkis
Contributor

alkis commented on Oct 24, 2017

@funny-falcon This makes sense +1

@arthurprs
Contributor

arthurprs commented on Oct 24, 2017

That's not reasonable, it's too easy to trip on that land-mine.

The most reasonable trade-off I've seen thus far is the two array map (OrderMap), that "fixes" the problem by making the degenerate case cheap to a point it can't really be exploited.

@alkis
Contributor

alkis commented on Oct 24, 2017

@arthurprs there is a way to "reseed" without requiring support from either BuildHasher or Hasher and placing no extra requirements to the user. Instead of hashing the key like this:

let mut state = hash_state.build_hasher();
t.hash(&mut state);
t.finish()

use the pointer to the buckets as additional bytes (this becomes a naturally occurring seed that changes at all the right places):

let mut state = hash_state.build_hasher();
state.write_usize(table.hash_start as usize);
t.hash(&mut state);
t.finish()

EDIT: The disadvantage to this solution is that if hash(usize) + hash(T) is slower than set_seed(seed) + hash(T) we get a suboptimal implementation. If there was an API in BuildHasher to create a Hasher with a specific seed then this could be done more efficiently across all hashers. This can be done by changing BuildHasher::build_hasher to take an additional argument. I am not sure how feasible this is at this point.

@arthurprs
Contributor

arthurprs commented on Oct 24, 2017

@alkis neat! That makes it general.

@alkis
Contributor

alkis commented on Oct 24, 2017

Any takers to implement this approach and close this bug once and forall? :-)

@arthurprs
Contributor

arthurprs commented on Oct 24, 2017

One has to provide proof that the performance hit isn't huge. I'd not be surprised if this fix yields a ~500% hit on grow/clone and a 20+% hit on lookup when using sip13.

@funny-falcon

There is even no need to calculate new hash value each time.
(Sorry, I don't know rust well, so I'll try to copy from above)

// key hash calculated once and stored
let mut state = hash_state.build_hasher();
t.hash(&mut state);
hashvalue = SafeHash.new(state.finish());
// position calculated dependent on storage pointer
// (example for 64bit)
poshash = hashvalue + (table.hash_start as usize);
poshash ^= poshash >> 32
poshash *= 0xdeadcafe71febeef; // or some other "well known" odd number (from Murmur, CityHash, etc)
poshash ^= poshash >> 32;

It will be enough for fixing bad case, and there is no need in recalculating SipHash.

@alkis
Contributor

alkis commented on Oct 24, 2017

@funny-falcon I do not think this will be very good. The pointer to hash_start has low entropy and the difference between one hash_starrt and another can be very small. I think mixing this way will weaken the composite hashfunction. Let's see how it works without this optimization first and then decide if this tradeoff is worth it. Perhaps some hash function experts can weigh in as well.

@funny-falcon

@alkis, just try. It will be just enough to fix bad case. There is no need to be better.

I think mixing this way will weaken the composite hashfunction

No way. hashvalue calculated with SipHash, and poshash is calculated in bijective way (ie it is revertible).

Multiplying by a "random looking" constant and shifting provides really good results. This is a well-known technique (Knuth multiplicative hashing).

Simulation (in C):

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>

uint64_t poshash(uint64_t hv, uint64_t hs) {
	uint64_t ph;
	ph = hv + hs;
	ph ^= ph >> 32;
	ph *= 0xdeadcafe71febeeful;
	ph ^= ph >> 32;
	return ph;
}

int main(int ac, char** av) {
	int i, j;
	uint64_t hv1, hv2, hv3, hashstart;
	uint64_t ph1, ph2, ph3;
	uint64_t masks[3] = {0xffff, 0x7fff, 0x3fff};

	hv1 = 0x123456789abcdef0ul;
	hv2 = 0x98523aed81fcdef0ul;
	hv3 = 0x3fa83924dcbcdef0ul;
	hashstart = 0x00007fe342e50000ul;
	printf("\thv1\thv2\thv3\n");
	for (j=0; j<3; j++) {
		uint64_t mask = masks[j];
		printf("%lx\t%lx\t%lx\t%lx\n",
			mask, hv1 & mask, hv2 & mask, hv3 & mask);
	}
	for (i=0; i<5; i++) {
		uint64_t ph1, ph2, ph3;
		ph1 = poshash(hv1, hashstart);
		ph2 = poshash(hv2, hashstart);
		ph3 = poshash(hv3, hashstart);
		printf("\t----\t----\t----\n");
		for (j=0; j<3; j++) {
			uint64_t mask = masks[j];
			printf("%lx\t%04lx\t%04lx\t%04lx\n",
				mask, ph1 & mask, ph2 & mask, ph3 & mask);
		}
		hashstart += 0x100ul; /* next allocation */
	}
}

results:

mask hv1 hv2 hv3
ffff def0 def0 def0
7fff 5ef0 5ef0 5ef0
3fff 1ef0 1ef0 1ef0
----- ------- ------- ------
ffff 8b86 f7a3 ae2e
7fff 0b86 77a3 2e2e
3fff 0b86 37a3 2e2e
----- ------- ------- ------
ffff fd87 41a6 202d
7fff 7d87 41a6 202d
3fff 3d87 01a6 202d
----- ------- ------- ------
ffff 6f85 d3a5 522c
7fff 6f85 53a5 522c
3fff 2f85 13a5 122c
----- ------- ------- ------
ffff 518c 1ddf c42a
7fff 518c 1ddf 442a
3fff 118c 1ddf 042a
----- ------- ------- ------
ffff c38d afde 7629
7fff 438d 2fde 7629
3fff 038d 2fde 3629
@funny-falcon

funny-falcon commented on Oct 24, 2017

https://en.wikipedia.org/wiki/Universal_hashing#Constructions

It is possible to use more sofisticated "multiply-add-shift":

ph = hashvalue + (table.hash_start as usize);
ph ^= ph >> 32;
ph *= 0xacd5ad43274593b9;
ph += 0x6956ab76ed268a3d;
ph ^= ph >> 32;

But really there is no need for the usecase. Just "multiply-shift" is more than enough.

@lily-commure
Contributor

lily-commure commented on Sep 25, 2019

Now that #58623 is merged, the HashMap implementation uses quadratic probing instead of linear or Robin-Hood. Is this bug still open?

Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment
Projects
None yet
Linked pull requests

Successfully merging a pull request may close this issue.

None yet
You can’t perform that action at this time.